<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="位号/管线号" prop="tagNo">
        <el-input
          v-model="queryParams.tagNo"
          placeholder="请输入位号/管线号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="设备名称" prop="equipmentName">
        <el-input
          v-model="queryParams.equipmentName"
          placeholder="请输入设备名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="图号" prop="pidNo">
        <el-input
          v-model="queryParams.pidNo"
          placeholder="请输入图号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-if="isApprove==0"
          v-hasPermi="['pssr:overhaulPump:add']"
        >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-if="isApprove==0"
          v-hasPermi="['pssr:overhaulPump:edit']"
        >修改
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="multiple"
          @click="handleBatch"
          v-if="isApprove==0"
          v-hasPermi="['pssr:overhaulPump:edit']"
        >批量修改
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-if="isApprove==0"
          v-hasPermi="['pssr:overhaulPump:remove']"
        >删除
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="info"
          icon="el-icon-upload2"
          size="mini"
          @click="handleImport"
          v-if="isApprove==0"
          v-hasPermi="['pssr:overhaulPump:edit']"
        >导入
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-if="isApprove==0"
          v-hasPermi="['pssr:overhaulPump:export']"
        >导出
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-s-promotion"
          size="mini"
          @click="handleApprove"
          v-if="isApprove==0"
          v-hasPermi="['pssr:overhaulPump:edit']"
        >发起审批
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-refresh-left"
          size="mini"
          v-if="isApprove==2"
          :disabled="multiple"
          @click="handleTurnDown"
          v-hasPermi="['pssr:overhaulPump:edit']"
        >驳回
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-check"
          size="mini"
          v-if="isApprove==4"
          @click="handleConfirmApprove"
          v-hasPermi="['pssr:overhaulPump:edit']"
        >确认
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>
    <div style="width: 100%;text-align: center;margin-bottom: 15px">
      <H2>泵更换清单</H2>
    </div>
    <el-table v-loading="loading" :data="overhaulPumpList" @selection-change="handleSelectionChange"
              :height="clientHeight" border>
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="审批状态" align="center" prop="approveStatus" width="120">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.pssr_approve_status" :value="scope.row.approveStatus" :show-type="getTagType(scope.row.approveStatus)"/>
        </template>
      </el-table-column>
      <el-table-column label="位号/管线号" align="center" prop="tagNo" :show-overflow-tooltip="true"/>
      <el-table-column label="设备名称" align="center" prop="equipmentName" :show-overflow-tooltip="true"/>
      <el-table-column label="检修内容" align="center" prop="workDes" :show-overflow-tooltip="true"/>
      <el-table-column label="图号" align="center" prop="pidNo" :show-overflow-tooltip="true"/>
      <el-table-column label="确认人" align="center" prop="confirmerName" :show-overflow-tooltip="true"/>
      <el-table-column label="完成日期" align="center" prop="completionDate" width="100">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.completionDate, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="驳回原因" align="center" prop="reason" :show-overflow-tooltip="true"/>
      <el-table-column label="备注" align="center" prop="remarks" :show-overflow-tooltip="true"/>
      <el-table-column label="操作" align="center" fixed="right" v-if="isApprove==0"
                       class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-folder"

            @click="handleDoc(scope.row)"
          >附件({{scope.row.fileNum}})
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['pssr:overhaulPump:edit']"
          >修改
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['pssr:overhaulPump:remove']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改检修项目-泵对话框 -->
    <el-dialog :close-on-click-modal="false" :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="位号/管线号" prop="tagNo">
          <el-input v-model="form.tagNo" placeholder="请输入位号/管线号"/>
        </el-form-item>
        <el-form-item label="设备名称" prop="equipmentName">
          <el-input v-model="form.equipmentName" placeholder="请输入设备名称"/>
        </el-form-item>
        <el-form-item label="检修内容" prop="workDes">
          <el-input v-model="form.workDes" placeholder="请输入检修内容"/>
        </el-form-item>
        <el-form-item label="图号" prop="pidNo">
          <el-input v-model="form.pidNo" placeholder="请输入图号"/>
        </el-form-item>
        <el-form-item label="完成日期" prop="completionDate">
          <el-date-picker clearable size="small" style="width: 200px"
                          v-model="form.completionDate"
                          type="date"
                          value-format="yyyy-MM-dd"
                          placeholder="选择完成日期">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="确认人" prop="confirmedPerson">
          <el-select v-model="form.confirmedPerson" clearable filterable style="width: 100%;"
                     placeholder="请选择确认人">
            <el-option v-for="user in userOptions"
                       :label="user.nickName"
                       :value="user.userId+''"
                       :key="user.userId"/>
          </el-select>
        </el-form-item>
        <el-form-item label="备注" prop="remarks">
          <el-input v-model="form.remarks" placeholder="请输入备注"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!-- 批量修改对话框 -->
    <el-dialog :close-on-click-modal="false" title="批量修改" :visible.sync="openBatch" width="500px" append-to-body>
      <el-form ref="form" :model="form" label-width="80px">
        <el-form-item>
          <span>已选择 {{ ids.length }} 条数据</span>
        </el-form-item>
        <el-form-item label="确认人1" prop="confirmedPerson"
                      v-if="isApprove==0">
          <el-select v-model="form.confirmedPerson" clearable filterable style="width: 100%;"
                     placeholder="请选择确认人1">
            <el-option v-for="user in userOptions"
                       :label="user.nickName"
                       :value="user.userId+''"
                       :key="user.userId"/>
          </el-select>
        </el-form-item>

        <el-form-item label="时间"  v-hasPermi="['pssr:date:edit']" prop="completionDate">
          <el-date-picker clearable size="small" style="width: 200px"
                          v-model="form.completionDate"
                          type="date"
                          value-format="yyyy-MM-dd"
                          placeholder="选择时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="备注" prop="remarks">
          <el-input v-model="form.remarks" placeholder="请输入备注"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFormBatch">确 定</el-button>
        <el-button @click="cancelBatch">取 消</el-button>
      </div>
    </el-dialog>
      <!-- 用户导入对话框 -->
    <el-dialog :close-on-click-modal="false" :title="upload.title" :visible.sync="upload.open" width="400px"
               append-to-body>
      <el-upload
        ref="upload"
        :limit="1"
        accept=".xlsx, .xls"
        :headers="upload.headers"
        :action="upload.url + '?updateSupport=' + upload.updateSupport"
        :disabled="upload.isUploading"
        :on-progress="handleFileUploadProgress"
        :on-success="handleFileSuccess"
        :auto-upload="false"
        drag
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">
          将文件拖到此处，或
          <em>点击上传</em>
        </div>
        <div class="el-upload__tip" slot="tip">
          <el-checkbox v-model="upload.updateSupport"/>
          是否更新已经存在的用户数据
          <el-link type="info" style="font-size:12px" @click="importTemplate">下载模板</el-link>
        </div>
        <div class="el-upload__tip" style="color:red" slot="tip">提示：仅允许导入“xls”或“xlsx”格式文件！</div>
      </el-upload>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFileForm">确 定</el-button>
        <el-button @click="upload.open = false">取 消</el-button>
      </div>
    </el-dialog>

    <!-- 附件对话框 -->
    <el-dialog v-dialogDrag :close-on-click-modal="false" :visible.sync="doc_p.open" append-to-body title="现场照片"
               width="1000px">
      <el-image v-for="file in doc_p.fileList" :key="file.id" :src="file.fileUrl" lazy></el-image>
    </el-dialog>
  </div>
</template>

<script>
import {
  addOverhaulPump,
  delOverhaulPump,
  exportOverhaulPump,
  getOverhaulPump,
  handleConfirmApprove,
  handleTurnDownPump,
  importTemplate,
  listOverhaulPump,
  updateOverhaulPump,
  updateOverhaulPumpBatch,
} from "@/api/pssr/overhaulPump";
import {treeselect} from "@/api/system/dept";
import {getToken} from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import {groupList} from "@/api/pssr/region";
import {getPssrUser} from "@/api/pssr/aboveall";
import {listFile} from "@/api/pssr/file";
import {doApprove} from "@/api/pssr/approve";
import {getSubcontent} from "@/api/pssr/subcontent";
import {updateMaterialBatch} from "@/api/pssr/material";


export default {
  dicts:['pssr_approve_status'],
  name: "OverhaulPump",
  components: {Treeselect},
  props: {
    subId: {
      type: Number,
      default: 0
    },
    isApprove: {
      type: Number,
      default: 0
    },
  },
  data() {
    return {
      doc_p: {
        file: "",
        // 是否显示弹出层（报告附件）
        open: false,
        fileList: [],
        queryParams: {
          itemId: null,
          subId: this.subId,
          forShort: 'jxxm-b'
        },
      },
      regionGroupOptions: [],
      unitOptions: [],
      userOptions: [],
      region: null,
      unit: null,
      unitDes: null,
      subStatus: null,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 检修项目-泵表格数据
      overhaulPumpList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      clientHeight: 300,
      // 是否显示弹出层
      open: false,
      openBatch: false,
      // 用户导入参数
      upload: {
        // 是否显示弹出层（用户导入）
        open: false,
        // 弹出层标题（用户导入）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 设置上传的请求头部
        headers: {Authorization: "Bearer " + getToken()},
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/pssr/overhaulPump/importData"
      },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        subId: this.subId,
        approveId: null,
        tagNo: null,
        equipmentName: null,
        workDes: null,
        pidNo: null,
        completionDate: null,
        confirmedPerson: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        deptId: null,
        remarks: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {}
    };
  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
      this.$refs.tree.filter(val);
    }
  },
  created() {
    //设置表格高度对应屏幕高度
    this.$nextTick(() => {
      this.clientHeight = document.body.clientHeight - 350
    })

    this.getList();
    this.getTreeselect();
    getPssrUser({}).then(res => {
      this.userOptions = res.data
    });
    groupList({}).then(res => {
      this.regionGroupOptions = res.data;
    });
    getSubcontent(this.subId).then(res => {
      this.unit = res.data.unit
      this.region = res.data.region
      this.unitDes = res.data.unitDes
      this.subStatus = res.data.approveStatus
    })
  },
  methods: {
    handleTurnDown(val) {
      this.$prompt('请输入驳回原因', '提示', {
        confirmButtonText: '确认驳回',
        cancelButtonText: '取消',
      }).then(({value}) => {
        let data = {
          ids: this.ids,
          subId: this.subId,
          remarks: value
        }
        handleTurnDownPump(data).then(res => {
          this.msgSuccess("驳回成功");
        })
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '取消驳回'
        });
      });
    },
    getTagType(val){
      if (val==0){
        return ''
      }else if (val==1){
        return 'warning'
      }else if (val==2){
        return 'success'
      }
    },
    checkSelectable(row) {
      return (row.approveStatus == 1 && this.isApprove != 0) || this.isApprove == 0
    },
    handleConfirmApprove() {
      let data = {
        ids: this.ids,
        subId: this.subId,
      }
      handleConfirmApprove(data).then(res => {
        this.msgSuccess("确认成功");
        this.getList()
      })
    },
    /** 查询检修项目-泵列表 */
    getList() {
      this.loading = true;
      listOverhaulPump(this.queryParams).then(response => {
        this.overhaulPumpList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 查询部门下拉树结构 */
    getTreeselect() {
      treeselect().then(response => {
        this.deptOptions = response.data;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        subId: this.subId,
        approveId: null,
        tagNo: null,
        equipmentName: null,
        workDes: null,
        pidNo: null,
        completionDate: null,
        confirmedPerson: null,
        delFlag: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        deptId: null,
        remarks: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加检修项目-泵";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getOverhaulPump(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改检修项目-泵";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateOverhaulPump(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addOverhaulPump(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return delOverhaulPump(ids);
      }).then(() => {
        this.getList();
        this.msgSuccess("删除成功");
      })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有检修项目-泵数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return exportOverhaulPump(queryParams);
      }).then(response => {
        this.download(response.msg);
      })
    },
    /** 导入按钮操作 */
    handleImport() {
      this.upload.title = "用户导入";
      this.upload.open = true;
    },
    /** 下载模板操作 */
    importTemplate() {
      importTemplate().then(response => {
        this.download(response.msg);
      });
    },
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert(response.msg, "导入结果", {dangerouslyUseHTMLString: true});
      this.getList();
    },
    // 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    },
    /** 报告附件按钮操作 */
    handleDocP(row) {
      this.doc_p.fileList = []
      this.doc_p.open = true;
      this.doc_p.queryParams.itemId = row.id
      this.getPFileList()
    },
    getPFileList() {
      listFile(this.doc_p.queryParams).then(response => {
        this.doc_p.fileList = response.rows;
        this.doc_p.fileList.forEach(item => {
          item.fileUrl = process.env.VUE_APP_BASE_API + item.fileUrl;
        });
      });
    },

    /** 确认按钮操作*/
    handleApprove() {
      doApprove(this.subId).then(res => {
        this.msgSuccess("已发起确认流程");
        this.getList();
      })
    },
    handleBatch(){
      this.reset();
      this.openBatch = true
    },
    // 取消按钮
    cancelBatch() {
      this.openBatch = false;
      this.reset();
    },
    /** 提交按钮 */
    submitFormBatch() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.form.ids = this.ids
          updateOverhaulPumpBatch(this.form).then(response => {
            this.msgSuccess("修改成功");
            this.openBatch = false;
            this.getList();
          });
        }
      });
    },
  }
};
</script>
